-- credit to Neal (NeavUI)
local _, vCore = ...

function vCore:SpellID()
    local select = select
    local find = string.find
    local sub = string.sub

    hooksecurefunc(GameTooltip, "SetUnitBuff", function(self,...)
        if not vCoreDB.SpellID then return end
        local id = select(10, UnitBuff(...))
        if id then
            self:AddLine("SpellID: "..id, 1, 1, 1)
            self:Show()
        end
    end)

    hooksecurefunc(GameTooltip, "SetUnitDebuff", function(self,...)
        if not vCoreDB.SpellID then return end
        local id = select(10, UnitDebuff(...))
        if id then
            self:AddLine("SpellID: "..id, 1, 1, 1)
            self:Show()
        end
    end)

    hooksecurefunc(GameTooltip, "SetUnitAura", function(self,...)
        if not vCoreDB.SpellID then return end
        local id = select(10, UnitAura(...))
        if id then
            self:AddLine("SpellID: "..id, 1, 1, 1)
            self:Show()
        end
    end)

    hooksecurefunc("SetItemRef", function(link, text, button, chatFrame)
        if not vCoreDB.SpellID then return end
        if find(link,"^spell:") then
            local id = sub(link, 7)
            ItemRefTooltip:AddLine("SpellID: "..id, 1, 1, 1)
            ItemRefTooltip:Show()
        end
    end)

    GameTooltip:HookScript("OnTooltipSetSpell", function(self)
        if not vCoreDB.SpellID then return end
        local id = select(2, self:GetSpell())
        if id then
            for i = 1, self:NumLines() do
                if _G["GameTooltipTextLeft"..i]:GetText() == "SpellID: "..id then
                    return
                end
            end

            self:AddLine("SpellID: "..id, 1, 1, 1)
            self:Show()
        end
    end)
end
